/*
 * Created on Sep 6, 2004
 *
 */
package proxyconfig;

import javax.swing.*;
import java.awt.*;
import java.util.*;

/**
 * @author danjo
 * This is a panel in which buttons can be placed horizontally centered
 * and with a specified gap between the buttons
 */
public class CenteredButtonPanel extends JPanel {

    /**
     * 
     * @param buttonList The list of buttons to be added in the desired left to right order
     * @param buttonGap The gap between buttons
     */
    public CenteredButtonPanel(LinkedList buttonList, Dimension buttonGap) {
        
        setLayout(new BoxLayout(this, BoxLayout.X_AXIS));
        add(Box.createHorizontalGlue());

        ListIterator itr = buttonList.listIterator();

        add(Box.createRigidArea(buttonGap));

        while(itr.hasNext()) {
            
            JButton tempBT = (JButton) itr.next();
            add(tempBT);
            add(Box.createRigidArea(buttonGap));
        }
        add(Box.createHorizontalGlue());

    }
    
    
}
