/*
 * Created on Jan 18, 2005
 */
package proxyconfig;

import javax.swing.*;
import javax.swing.border.BevelBorder;

import proxyconfig.ocd.OCD;


import java.awt.*;
import java.awt.event.*;

/**
 * @author danjo
 */
public class OverlayDetailsPanel extends JPanel implements ActionListener {

    JTextField idTF;
    JTextField typeTF;
    JTextField descriptionTF;
    JCheckBox activeCB;
    JTextField urlSuffixesTF;
    JTextField configFileTF;
    
    OCD currOverlay = null;
    
    ProxyConfig proxyConfig;
    
    OverlayDetailsPanel(ProxyConfig proxyConfig) {
        
        this.proxyConfig = proxyConfig;
        
        setBorder(BorderFactory.createBevelBorder(BevelBorder.LOWERED));
        
		//Construct the GUI
		Insets insets = new Insets(2,2,2,2);
		GridBagLayout gbag = new GridBagLayout();
		setLayout(gbag);

		GridBagConstraints gc = new GridBagConstraints();
		gc.weighty = 0.0;
		gc.fill = GridBagConstraints.HORIZONTAL;
		gc.insets = insets;
		gc.gridx = GridBagConstraints.REMAINDER;
		gc.anchor = GridBagConstraints.WEST;

		
		JLabel tempLabel;
		JPanel tempPanel;

		
		// The preferred Dimension of all the input fields - mainly used to enforce a common height
		Dimension minDim = new Dimension(100, 25);
		
		tempLabel = new JLabel("OVERLAY ID");
		gc.gridx = 0;
		gc.gridy = 0;
		gc.weightx = 0.0;
		gbag.setConstraints(tempLabel, gc);
		add(tempLabel);

		idTF = new JTextField(20);
		idTF.setMinimumSize(minDim);

		
		typeTF = new JTextField(20);
		typeTF.setMinimumSize(minDim);

		tempPanel = new JPanel();
		tempPanel.setLayout(new BoxLayout(tempPanel, BoxLayout.X_AXIS));

		tempPanel.add(idTF);
		tempPanel.add(Box.createRigidArea(new Dimension(10,5)));
		tempLabel = new JLabel("TYPE");
		tempPanel.add(tempLabel);
		tempPanel.add(Box.createRigidArea(new Dimension(5,5)));
		tempPanel.add(typeTF);
		gc.gridx = 1;
		gc.gridy = 0;
		gc.weightx = 1.0;
		gbag.setConstraints(tempPanel, gc);
		add(tempPanel);

		

		tempLabel = new JLabel("AM I ACTIVE?");
		gc.gridx = 0;
		gc.gridy = 1;
		gc.weightx = 0.0;
		gbag.setConstraints(tempLabel, gc);
		add(tempLabel);

		activeCB = new JCheckBox();
		activeCB.setMinimumSize(minDim);
		gc.gridx = 1;
		gc.gridy = 1;
		gc.weightx = 1.0;
		gbag.setConstraints(activeCB, gc);
		add(activeCB);
		
		tempLabel = new JLabel("DESCRIPTION");
		gc.gridx = 0;
		gc.gridy = 2;
		gc.weightx = 0.0;
		gbag.setConstraints(tempLabel, gc);
		add(tempLabel);

		descriptionTF = new JTextField(50);
		descriptionTF.setMinimumSize(minDim);
		gc.gridx = 1;
		gc.gridy = 2;
		gc.weightx = 0.0;
		gbag.setConstraints(descriptionTF, gc);
		add(descriptionTF);



		tempLabel = new JLabel("URL SUFFIXES");
		gc.gridx = 0;
		gc.gridy = 3;
		gc.weightx = 0.0;
		gbag.setConstraints(tempLabel, gc);
		add(tempLabel);

		urlSuffixesTF = new JTextField(50);
		urlSuffixesTF.setMinimumSize(minDim);
		tempPanel = new JPanel();
		tempPanel.setLayout(new BoxLayout(tempPanel, BoxLayout.X_AXIS));
		tempPanel.add(urlSuffixesTF);
		tempPanel.add(new JLabel("  (separate suffixes by a space)"));
		gc.gridx = 1;
		gc.gridy = 3;
		gc.weightx = 1.0;
		gbag.setConstraints(tempPanel, gc);
		add(tempPanel);

		
		tempLabel = new JLabel("CONFIG FILE");
		gc.gridx = 0;
		gc.gridy = 4;
		gc.weightx = 0.0;
		gbag.setConstraints(tempLabel, gc);
		add(tempLabel);

		configFileTF = new JTextField();
		configFileTF.setMinimumSize(minDim);
		tempPanel = new JPanel();
		tempPanel.setLayout(new BoxLayout(tempPanel, BoxLayout.X_AXIS));
		tempPanel.add(configFileTF);
		
		JButton configFileChooseBT = new JButton("Choose File");
		configFileChooseBT.setActionCommand("CHOOSE_CONFIG_FILE");
		configFileChooseBT.addActionListener(this);
		tempPanel.add(configFileChooseBT);
		gc.gridx = 1;
		gc.gridy = 4;
		gc.weightx = 1.0;
		gbag.setConstraints(tempPanel, gc);
		add(tempPanel);
		
		JPanel buttonPanel = new JPanel();
		buttonPanel.setLayout(new BoxLayout(buttonPanel, BoxLayout.X_AXIS));
		buttonPanel.add(Box.createHorizontalGlue());
		JButton specificBT = new JButton("Click Here for Overlay Specific Configuration Options");
		specificBT.setActionCommand("OVERLAY_SPECIFIC");
		specificBT.addActionListener(this);
		buttonPanel.add(specificBT);
		buttonPanel.add(Box.createHorizontalGlue());

		gc.gridwidth = 2; 
		gc.gridx = 0;
		gc.gridy = 5;
		gc.weightx = 1.0;
		gbag.setConstraints(buttonPanel, gc);
		add(buttonPanel);
	
    }
    
    void setOverlay(OCD o) {
        
        currOverlay = o;
        if (o != null) {
            idTF.setText(o.id);
            typeTF.setText(o.type);
            activeCB.setSelected(o.isActive);
            descriptionTF.setText(o.description);
            configFileTF.setText(o.configFile);
        } else {
            idTF.setText("");
            typeTF.setText("");
            urlSuffixesTF.setText("");
            activeCB.setSelected(false);
            descriptionTF.setText("");
            configFileTF.setText("");

        }
    }
    public void actionPerformed(ActionEvent ae) {
     
        String cmd = ae.getActionCommand();
        
        if (cmd.equals("CHOOSE_CONFIG_FILE")) {
            chooseConfigFile();
        }
    }
    
    private void chooseConfigFile() {
        
        int retVal = proxyConfig.fc.showOpenDialog(proxyConfig);
        if (retVal == JFileChooser.APPROVE_OPTION) {
            configFileTF.setText(proxyConfig.fc.getSelectedFile().getPath());
        }
    }
    
    void updateOverlay() {
        if (currOverlay != null) {
            currOverlay.id = idTF.getText();
            currOverlay.type = typeTF.getText();
            currOverlay.description = descriptionTF.getText();
            currOverlay.configFile = configFileTF.getText();
            if (activeCB.isSelected()) {
                currOverlay.isActive = true;
            } else {
                currOverlay.isActive = false;
            }
        }
    }
}
