/*
 * Created on Jan 21, 2005
 */
package proxyconfig;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.Font;
import java.io.File;
import java.net.*;

import javax.swing.*;

import proxyconfig.mynames.*;
import proxyconfig.ocd.OCD;

import java.util.*;
import java.awt.*;
import java.awt.event.*;
import java.util.*;


/**
 * @author danjo
 */
public class WelcomePane extends JPanel implements ActionListener {

    private HashMap firstTimeNameMap = new HashMap();
    private HashMap firstTimePanelMap = new HashMap();
    
    ProxyConfig proxyConfig;
    
    WelcomePane(ProxyConfig proxyConfig) {
    
        this.proxyConfig = proxyConfig;
        
        setLayout(new BoxLayout(this, BoxLayout.Y_AXIS));
        setBackground (proxyconfig.ProxyConfig.WHITE_COLOR);
        
        JEditorPane welcomeLB = new JEditorPane();
        welcomeLB.setContentType("text/html");
        welcomeLB.setMaximumSize (new Dimension(700, 150));
        welcomeLB.setEditable(false);
        
        String welcomeStr1 = 
            "<br>" + "<font face=\"arial\">" +
             "<font size=\"6\" ><b>Welcome to the Generic Proxy Configurator!</b></font><br><br>" +
             "The following overlay networks are currently available in the proxy."
             ;
             
                
        welcomeLB.setText(welcomeStr1);

        add(welcomeLB);

        add(Box.createRigidArea (new Dimension(50,50)));
        
        ListIterator itr = proxyConfig.proxyConfigData.overlayList.listIterator();
        while (itr.hasNext()) {
            OCD currOverlay = (OCD) itr.next();
            JPanel horizPanel = new JPanel();
            horizPanel.setBackground(proxyconfig.ProxyConfig.WHITE_COLOR);
            add(horizPanel);
            
            horizPanel.setLayout(new BoxLayout(horizPanel, BoxLayout.X_AXIS));
            
            horizPanel.add (Box.createHorizontalGlue());
            
            JEditorPane overlayLB = new JEditorPane ( "text/html",
                    "<div align=\"left\"><font face=\"arial\" color=\"blue\" size=\"5\">" +
                    	currOverlay  +
                    "</font>"
            	);
            overlayLB.setPreferredSize(new Dimension(160,30));
            overlayLB.setMaximumSize(new Dimension(160,30));
            
            horizPanel.add(overlayLB);
            
            horizPanel.add (Box.createHorizontalGlue());
            
        }
        
        add (Box.createVerticalGlue());
   
    /*    if (proxyConfig.firstTimeFlag) {
            
            JEditorPane firstTimeLB = new JEditorPane();
            firstTimeLB.setContentType("text/html");
            firstTimeLB.setEditable(false);
            firstTimeLB.setMaximumSize (new Dimension(700,50));
            
            String firstTimeStr = 
                "<br>" + "<font face=\"arial\">" +
                 "The following names have been assigned to your machine."
                 ;
                 
                    
            firstTimeLB.setText(firstTimeStr);
            add(firstTimeLB);
            
            add(Box.createRigidArea (new Dimension(50,50)));
            
            ListIterator ocdItr = proxyConfig.proxyConfigData.overlayList.listIterator();
            while (ocdItr.hasNext()) {
                OCD currOCD = (OCD) ocdItr.next();
                if (currOCD.type.equals (OCD.OCD_TYPE_I3)) {
                    try {
                        InetAddress localAddress = InetAddress.getLocalHost ();
                        String tmpName = localAddress.getHostName() + "." + currOCD.id;
                        
                        MyName tmpMyName = new MyName ();
                        tmpMyName.active = true;
                        tmpMyName.name = tmpName;
                        tmpMyName.ocd = currOCD;
                        tmpMyName.ocdId = currOCD.id;
                        
                        tmpMyName.ocdSpecificProperties.put(I3OCD.I3_TRIGGER_TYPE, I3NameEditPanel.TRIGGER_TYPE_NORMAL);
                        
                        boolean nameExistsFlag = false;
                        
                        //go through my name list to see if same name already exists.  If not, add it.
                        ListIterator nameItr = proxyConfig.proxyConfigData.myNameList.listIterator();
                        while (nameItr.hasNext()) {
                            MyName currName = (MyName) nameItr.next();
                            if (currName.name.equals (tmpName)) {
                                nameExistsFlag = true;
                                tmpMyName = currName;
                                break;
                            }
                        }
                        
                        if (nameExistsFlag == false) {
                            proxyConfig.proxyConfigData.myNameList.add(tmpMyName);
                            proxyConfig.changeListener.setChanged(true);
                        } 
                        
                        JPanel horizPanel = new JPanel();
                        horizPanel.setBackground(proxyconfig.ProxyConfig.WHITE_COLOR);
                        add(horizPanel);
                        
                        horizPanel.setLayout(new BoxLayout(horizPanel, BoxLayout.X_AXIS));
                        
                        horizPanel.add (Box.createHorizontalGlue());
                        
                        JEditorPane nameLB;
                        
                        nameLB = new JEditorPane ( "text/html",
                                "<div align=\"left\"><font face=\"arial\" color=\"blue\" size=\"5\">" +
                                tmpName +
                                "</font>"
                    		);
                        
                        
                        nameLB.setPreferredSize(new Dimension(250,30));
                        nameLB.setMaximumSize(new Dimension(250,30));
                        
                        horizPanel.add(nameLB);
                        
                        JEditorPane nameCertLB;
                        
                        if (! tmpMyName.certOKFlag.equals (MyName.CERT_VALID)) {
                            nameCertLB = new JEditorPane ( "text/html",
                                                                       "</font> <font color=\"red\" size=\"-1\"><i>(Certificate not specified)</i></font>"
                        		);
                        } else {
                            nameCertLB = new JEditorPane ("text/html", "");
                        }
                        
                        tmpMyName.nameCertLB = nameCertLB;
                        nameCertLB.setPreferredSize(new Dimension(150,30));
                        nameCertLB.setMaximumSize(new Dimension(150,30));

                        horizPanel.add(nameCertLB);
                        
                        
                        horizPanel.add(Box.createRigidArea(new Dimension(20,20)));
                        
                        JButton changeBT = new JButton("Change");
                        changeBT.setActionCommand("CHANGE_" + tmpName);
                        changeBT.addActionListener (this);
                        horizPanel.add(changeBT);
                        horizPanel.add (Box.createRigidArea(new Dimension(10,10)));
                        firstTimeNameMap.put ("CHANGE_" + tmpName, tmpMyName);
                        firstTimePanelMap.put ("CHANGE_" + tmpName, horizPanel);
                        
                        JButton delBT = new JButton("Delete");
                        delBT.setActionCommand("DEL_" + tmpName);
                        delBT.addActionListener (this);
                        horizPanel.add(delBT);
                        horizPanel.add (Box.createHorizontalGlue());

                        firstTimeNameMap.put ("DEL_" + tmpName, tmpMyName);
                        firstTimePanelMap.put ("DEL_" + tmpName, horizPanel);
                        
                    } catch (UnknownHostException uhe) {
                        System.out.println ("Unable to obtain local machine name.\n");
                    }
                }
            }
        } */
        add(Box.createVerticalGlue());

    }
    
    public void actionPerformed (ActionEvent ae) {
        String cmd = ae.getActionCommand();
        
        MyName currRecord = (MyName) firstTimeNameMap.get(cmd);
        if (currRecord != null) {
            if (cmd.startsWith("CHANGE_")) {
                proxyConfig.myNamePanel.editRecord(currRecord);
            } else if (cmd.startsWith ("DEL_")) {
                if (proxyConfig.myNamePanel.delRecord (currRecord)) {
                    JPanel tmpPanel = (JPanel) firstTimePanelMap.get(cmd);
                    tmpPanel.setVisible (false);
                }
                
            }
        }
    }
    
}
