/*
 * Created on May 18, 2005
 */
package proxyconfig.certificate;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;
import java.util.Iterator;

import javax.swing.Box;
import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JFileChooser;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JTextField;

import proxyconfig.ProxyConfig;
import proxyconfig.i3.I3NameEditPanel;
import proxyconfig.mynames.MyName;
import proxyconfig.ocd.OCD;
import proxyconfig.ron.RONNameEditPanel;

/**
 * @author danjo
 */
public class CertificateRequestPanel extends JPanel {

    JTextField nameTF;
    JTextField realNameTF;
    
    JTextField emailTF;
    
    public CertificateRequestPanel() {

        setBackground(proxyconfig.ProxyConfig.BACKGROUND_COLOR);
        setLayout (new BoxLayout (this, BoxLayout.Y_AXIS));
        
        JPanel mainPanel = new JPanel();
        mainPanel.setBackground (proxyconfig.ProxyConfig.BACKGROUND_COLOR);
        add (mainPanel);
        
    	//Construct the GUI
		Insets insets = new Insets(2,2,2,2);
		GridBagLayout gbag = new GridBagLayout();
		mainPanel.setLayout(gbag);

		GridBagConstraints gc = new GridBagConstraints();
		gc.weighty = 0.0;
		gc.fill = GridBagConstraints.HORIZONTAL;
		gc.insets = insets;
		gc.gridx = GridBagConstraints.REMAINDER;
		gc.anchor = GridBagConstraints.WEST;

		JLabel tempLabel;

		// The preferred Dimension of all the input fields - mainly used to enforce a common height
		Dimension minDim = new Dimension(50, 25);
		
		tempLabel = new JLabel("Requested Name");
		tempLabel.setBackground(proxyconfig.ProxyConfig.BACKGROUND_COLOR);
		gc.gridx = 0;
		gc.gridy = 0;
		gc.weightx = 0.0;
		gbag.setConstraints(tempLabel, gc);
		mainPanel.add(tempLabel);

		nameTF = new JTextField(20);
		nameTF.setMinimumSize(minDim);
		nameTF.setBackground(ProxyConfig.INPUT_BOX_COLOR);
        nameTF.setEditable(false);
		gc.gridx = 1;
		gc.gridy = 0;
		gc.weightx = 1.0;
		gbag.setConstraints(nameTF, gc);
		mainPanel.add(nameTF);

		
		tempLabel = new JLabel("Real Name");
		tempLabel.setBackground(proxyconfig.ProxyConfig.BACKGROUND_COLOR);
		gc.gridx = 0;
		gc.gridy = 1;
		gc.weightx = 0.0;
		//gbag.setConstraints(tempLabel, gc);
		//mainPanel.add(tempLabel);
	    
		realNameTF = new JTextField(20);
		realNameTF.setMinimumSize(minDim);
		realNameTF.setBackground(ProxyConfig.INPUT_BOX_COLOR);
		gc.gridx = 1;
		gc.gridy = 1;
		gc.weightx = 1.0;
		//gbag.setConstraints(realNameTF, gc);
		//mainPanel.add(realNameTF);

		tempLabel = new JLabel("Email Address");
		tempLabel.setBackground(proxyconfig.ProxyConfig.BACKGROUND_COLOR);
		gc.gridx = 0;
		gc.gridy = 2;
		gc.weightx = 0.0;
		gbag.setConstraints(tempLabel, gc);
		mainPanel.add(tempLabel);
	    
		emailTF = new JTextField(20);
		emailTF.setMinimumSize(minDim);
		emailTF.setBackground(ProxyConfig.INPUT_BOX_COLOR);
		gc.gridx = 1;
		gc.gridy = 2;
		gc.weightx = 1.0;
		gbag.setConstraints(emailTF, gc);
		mainPanel.add(emailTF);

		
		tempLabel = new JLabel("Your confirmation password will be sent to the above email address");
		tempLabel.setBackground(proxyconfig.ProxyConfig.BACKGROUND_COLOR);
		gc.gridx = 0;
		gc.gridy = 3;
		gc.weightx = 0.0;
		gc.gridwidth = 2;
		gbag.setConstraints(tempLabel, gc);
		mainPanel.add(tempLabel);

        emailTF.requestFocus();

    }
   
    public void setFocus() {
        emailTF.requestFocus();
    }

    public Dimension getPreferredSize() {
        
        return new Dimension(600,300);
    }

    boolean checkFields() {
        boolean retVal = true;
        
        String msg = "";

        if (nameTF.getText().trim().equals("")) {
            retVal = false;
            msg += "Name field should not be empty.\n";
        }
        
        String tmpEmailAddr = emailTF.getText().trim();
        int loc = tmpEmailAddr.indexOf('@');
        if (loc == -1) {
            msg += "The email address \'" + tmpEmailAddr + "\' is invalid.\n";
            retVal = false;
        }
        
        if (!retVal) {
            JOptionPane.showMessageDialog( null,
                    msg,
                    "Error in Name",
                    JOptionPane.ERROR_MESSAGE
        		);
        }
        return retVal;
    }

}
