/*
 * Created on Jan 22, 2005
 */
package proxyconfig.i3;

import java.awt.Dimension;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;

import javax.swing.*;

import proxyconfig.ProxyConfig;

import java.awt.*;

/**
 * @author danjo
 */
public class I3AddressBookEntryPanel extends JPanel {

    JTextField nameTF;
    JTextField i3IdTF;
    
    I3AddressBookEntryPanel() {
        
        setBackground(proxyconfig.ProxyConfig.BACKGROUND_COLOR);
        
    	//Construct the GUI
		Insets insets = new Insets(2,2,2,2);
		GridBagLayout gbag = new GridBagLayout();
		setLayout(gbag);

		GridBagConstraints gc = new GridBagConstraints();
		gc.weighty = 0.0;
		gc.fill = GridBagConstraints.HORIZONTAL;
		gc.insets = insets;
		gc.gridx = GridBagConstraints.REMAINDER;
		gc.anchor = GridBagConstraints.WEST;

		
		JLabel tempLabel;

		// The preferred Dimension of all the input fields - mainly used to enforce a common height
		Dimension minDim = new Dimension(50, 25);
		
		tempLabel = new JLabel("Name/URL");
		tempLabel.setBackground(Color.WHITE);
		gc.gridx = 0;
		gc.gridy = 0;
		gc.weightx = 0.0;
		gbag.setConstraints(tempLabel, gc);
		add(tempLabel);

		nameTF = new JTextField(40);
		nameTF.setMinimumSize(minDim);
		nameTF.setBackground(ProxyConfig.INPUT_BOX_COLOR);
		
		gc.gridx = 1;
		gc.gridy = 0;
		gc.weightx = 1.0;
		gbag.setConstraints(nameTF, gc);
		add(nameTF);

		tempLabel = new JLabel("I3 Id");
		tempLabel.setBackground(Color.WHITE);
		gc.gridx = 0;
		gc.gridy = 1;
		gc.weightx = 0.0;
		gbag.setConstraints(tempLabel, gc);
		add(tempLabel);
	    
		i3IdTF = new JTextField(40);
		i3IdTF.setMinimumSize(minDim);
		i3IdTF.setBackground(ProxyConfig.INPUT_BOX_COLOR);
		gc.gridx = 1;
		gc.gridy = 1;
		gc.weightx = 1.0;
		gbag.setConstraints(i3IdTF, gc);
		add(i3IdTF);
		
		nameTF.requestFocus();
	

		
    }
    
    void setEntry(I3AddressBookEntry e) {
        nameTF.setText(e.name);
        i3IdTF.setText(e.i3Id);
    }
    
    boolean updateEntry(I3AddressBookEntry e) {
        e.name = nameTF.getText();
        e.i3Id = i3IdTF.getText();
        
        return true;
    
    }
    
    boolean checkFields() {
        boolean retVal = true;
        
        String msg = "";
        
        
        if (nameTF.getText().trim().equals("")) {
            retVal = false;
            msg += "Name field should not be empty.\n";
        }

        if (i3IdTF.getText().trim().equals("")) {
            retVal = false;
            msg += "I3 Id field should not be empty.";
        }

        if (! retVal) {
            JOptionPane.showMessageDialog( null,
                    msg,
                    "Invalid I3 Address Book Entry",
                    JOptionPane.ERROR_MESSAGE
        		);
        }
        
        return retVal;

    }
}
