/*
 * Created on Jan 18, 2005
 */
package proxyconfig.ocd;

import proxyconfig.*;
import proxyconfig.mynames.*;
import java.util.*;
import java.io.*;

/**
 * Represents an OverlayNetwork
 * @author danjo
 */
public class OCD {
    
    public static final String OCD_TYPE_I3 = "I3";
    public static final String OCD_TYPE_RON = "RON";
    
    public String id;
    public String type;
    public String description;
	public String configFile;
	public String libFileName_windows;
	public String libFileName_linux;
	public String libFileName_apple;
	
	public boolean isActive;

	public HashMap propertyMap;
	
	public OCD () {
	    propertyMap = new HashMap();
	}
	
	/**
	 * The base function must be invoked by the overloaded
	 * function/
	 * @param o
	 */
	public void init (OCD o) {
	    id = o.id;
        type = o.type;
        description = o.description;
        configFile = o.configFile;
        isActive = o.isActive;
        libFileName_windows = o.libFileName_windows;
        libFileName_linux = o.libFileName_linux;
        libFileName_apple = o.libFileName_apple;
        
        propertyMap = o.propertyMap;    
	}
	
	public String toString() {
        return id;
    }

	public void addProperty (String property, String value) {
	    propertyMap.put(property, value);
	}
	
	public String getProperty (String property) {
	    return (String) propertyMap.get(property);
	}
	
	/** Must be overridden.
	 * @param proxyConfig
	 * @return
	 */
	public OCDWizardDialog getNewWizard (ProxyConfig proxyConfig) {
	    
	    return null;	    
	}

	/** Get any configuration data from the wizard screen to the 
	 * actual OCD.
	 */
	public void updateFromWizard() {
	    
	}
	
	public void writeToDisk() throws IOException {
	    
	}

	public void initNameInNameWizard(MyName tmpName) {
	
	}
	
	public OCDNameEditPanel getNewNameEditPanel (MyName tmpName) {
	    return null;
	}
}
