/*
 * Created on Jan 18, 2005
 */
package proxyconfig.outboundconnections;

import proxyconfig.*;

import javax.swing.*;
import javax.swing.border.BevelBorder;
import javax.swing.table.DefaultTableCellRenderer;

import proxyconfig.CenteredButtonPanel;
import proxyconfig.MessageLabel;
import proxyconfig.ProxyConfig;
import proxyconfig.ocd.OCD;

import java.awt.*;
import java.awt.event.*;
import java.net.URL;
import java.util.*;

/**
 * @author danjo
 */
public class OutboundPanel extends JPanel implements ActionListener {
    OutboundTable outboundTable;
    OutboundTableModel outboundTableModel;

    ProxyConfig proxyConfig;
    
    public OutboundPanel(ProxyConfig proxyConfig) {
        
        this.proxyConfig = proxyConfig;
        proxyConfig.changeListener.setEnabled(false);
        
        setLayout(new BoxLayout(this, BoxLayout.Y_AXIS));
        
        setBackground(proxyconfig.ProxyConfig.BACKGROUND_COLOR);
        
        setBorder(BorderFactory.createLineBorder(Color.BLACK));

        JPanel tmpPanel;
        
        /*
        tmpPanel = new JPanel();
        tmpPanel.setBackground(Color.WHITE);
        tmpPanel.setLayout(new BoxLayout(tmpPanel, BoxLayout.X_AXIS));
        add(tmpPanel);
        JEditorPane overlayTitleLB = new JEditorPane("text/html",
                "Available overlays"
                );
        overlayTitleLB.setBackground(Color.WHITE);
        overlayTitleLB.setMaximumSize(new Dimension(500,120));
        overlayTitleLB.setEditable(false);
        tmpPanel.add(Box.createHorizontalGlue());
        tmpPanel.add(overlayTitleLB);
        tmpPanel.add(Box.createHorizontalGlue());

        add(Box.createRigidArea(new Dimension(15,15)));

        */
        

        add(new MessageLabel(
                "URL to Path Mappings", 
                ProxyConfig.HEADING_COLOR, 	//background color
                24 //font size
                ));
        
        
        add(Box.createRigidArea(new Dimension(10,10)));

        
        /*
        tmpPanel = new JPanel();
        tmpPanel.setBackground(Color.WHITE);
        tmpPanel.setLayout(new BoxLayout(tmpPanel, BoxLayout.X_AXIS));
        add(tmpPanel);
        JEditorPane titleLB = new JEditorPane("text/html",
                "Here you can configure the overlay which should handle URLs satisfying specific patterns.  " +
                "For example, you may want all URLs of the form *.mil to go through an overlay X and URLs of the form " +
                "*berkeley* to be handled by some other overlay Y. " +
                "<br><br>The arrows on the side of the table are used to order the rules.  When deciding the overlay to use for a particular URL, the proxy scans the list from top to bottom and stops at the first match."
                
                );
        titleLB.setBackground(Color.WHITE);
        titleLB.setMaximumSize(new Dimension(500,120));
        titleLB.setEditable(false);
        tmpPanel.add(titleLB);
        tmpPanel.add(Box.createHorizontalGlue());

        add(Box.createRigidArea(new Dimension(15,15)));
        
        */
        JPanel contentPanel = new JPanel();
        contentPanel.setBackground(proxyconfig.ProxyConfig.BACKGROUND_COLOR);
        
        contentPanel.setLayout(new BoxLayout(contentPanel, BoxLayout.Y_AXIS));
        add(contentPanel);

        
        JPanel tablePanel = new JPanel();
        
        tablePanel.setBackground(proxyconfig.ProxyConfig.BACKGROUND_COLOR);
        tablePanel.setBorder(BorderFactory.createBevelBorder(BevelBorder.LOWERED));
        tablePanel.setLayout(new BoxLayout(tablePanel, BoxLayout.X_AXIS));
        contentPanel.add(tablePanel);
        
        String columns[] = {"URL Pattern","Path", "Security"};
        
        outboundTableModel = new OutboundTableModel(columns);
        
        outboundTable = new OutboundTable(outboundTableModel);
        outboundTable.setPreferredSize(new Dimension(500,450));
        JScrollPane urlTableScroller = new JScrollPane(outboundTable);
        urlTableScroller.setBackground(proxyconfig.ProxyConfig.BACKGROUND_COLOR);
        tablePanel.add(urlTableScroller);
        
        JPanel reorderButtonPanel = new JPanel();
        reorderButtonPanel.setBackground(proxyconfig.ProxyConfig.BACKGROUND_COLOR);
        reorderButtonPanel.setLayout(new BoxLayout(reorderButtonPanel, BoxLayout.Y_AXIS));
        
        URL upBTURL = getClass().getResource("/upBT.gif");
        JButton upBT = new JButton(new ImageIcon(Toolkit.getDefaultToolkit().getImage(upBTURL)));

        upBT.setActionCommand("MOVE_PATTERN_UP");
        upBT.addActionListener(this);
        upBT.setToolTipText("Move selected pattern up");
        reorderButtonPanel.add(upBT);

        URL downBTURL = getClass().getResource("/downBT.gif");
        JButton downBT = new JButton(new ImageIcon(Toolkit.getDefaultToolkit().getImage(downBTURL)));
        
        downBT.setToolTipText("Move selected pattern down");
        downBT.setActionCommand("MOVE_PATTERN_DOWN");
        downBT.addActionListener(this);
        reorderButtonPanel.add(downBT);
        
        tablePanel.add(reorderButtonPanel);
        
        LinkedList buttonList = new LinkedList();
        
        JButton addBT = new JButton("Add New URL Pattern");
        addBT.setActionCommand("ADD_PATTERN");
        addBT.addActionListener(this);
        buttonList.add(addBT);

        JButton editBT = new JButton("Modify Selected URL Pattern");
        editBT.setActionCommand("EDIT_PATTERN");
        editBT.addActionListener(this);
        buttonList.add(editBT);

        JButton delBT = new JButton("Delete Selected URL Pattern ");
        delBT.setActionCommand("DEL_PATTERN");
        delBT.addActionListener(this);
        buttonList.add(delBT);

        add(Box.createRigidArea(new Dimension(10,10)));
        
        CenteredButtonPanel buttonPanel = new CenteredButtonPanel(buttonList, new Dimension(5,5));
        buttonPanel.setBackground(proxyconfig.ProxyConfig.BACKGROUND_COLOR);
        contentPanel.add(buttonPanel);    
        
        
        ListIterator itr = proxyConfig.proxyConfigData.outboundList.listIterator();
        while (itr.hasNext()) {
            OutboundRecord tmpRecord = (OutboundRecord) itr.next();
            if ( ! tmpRecord.ocdDefaultFlag) {
                outboundTableModel.addRecord(tmpRecord);
            }
        }

    }
    
    /*
    public void refreshOverlay(OCD o) {
        
        ListIterator itr = outboundTableModel.getRecordList().listIterator();
        while (itr.hasNext()) {
            
            OutboundRecord r = (OutboundRecord) itr.next();
            if (r.overlay != null && r.overlay.id.equals(o.id )){
                r.overlay =o;
                r.overlayId = o.id;
            }
            
        }
        outboundTableModel.fireTableDataChanged();
        
       
    }
    */
    
    void checkOverlay(OCD chkOverlay, JCheckBox currCheckBox) {
    
        boolean invalidFlag = false;
        
        ListIterator itr = outboundTableModel.getRecordList().listIterator();
        while (itr.hasNext()) {
            OutboundRecord tmpRec = (OutboundRecord) itr.next();
            if ( !chkOverlay.isActive && 
                    (tmpRec.containsHop(chkOverlay.id))
                    ) {
                invalidFlag = true;
            }
        }
        
        if (invalidFlag) {
            int retVal = JOptionPane.showConfirmDialog(null,
                    "There are URLs mapping to the inactive overlay " + chkOverlay.id + "." +
                    "\nAre you sure you want to inactivate this overlay?",
                    "Invalid URL mappings",
                    JOptionPane.YES_NO_OPTION,
                    JOptionPane.WARNING_MESSAGE
                    );
            
            if (retVal == JOptionPane.NO_OPTION) {
                currCheckBox.setSelected(true);
                chkOverlay.isActive = true;
            }
        
        }
        outboundTableModel.fireTableDataChanged();
    }
    
    public void update() {

        proxyConfig.proxyConfigData.outboundList = outboundTableModel.getRecordList();
    }
    
    public void actionPerformed(ActionEvent ae) {
        
        String cmd = ae.getActionCommand();
        
        if (cmd.equals("MOVE_PATTERN_UP")) {
            int selRow = outboundTable.getSelectedRow();
            outboundTableModel.moveRecordUp(selRow);
            proxyConfig.changeListener.setChanged(true);
        }  else if (cmd.equals("MOVE_PATTERN_DOWN")) {
            int selRow = outboundTable.getSelectedRow();
            outboundTableModel.moveRecordDown(selRow);
            proxyConfig.changeListener.setChanged(true);
        
        } else if (cmd.equals("ADD_PATTERN")) {
            
            OutboundEditPanel outboundEditPanel = new OutboundEditPanel(proxyConfig);
            
            ProxyConfig.changeOptionPaneBackground(Color.WHITE);
            
            while (true) {
                int retVal = JOptionPane.showConfirmDialog(null, outboundEditPanel, "Enter new URL pattern", JOptionPane.OK_CANCEL_OPTION);
            	if (retVal == JOptionPane.OK_OPTION) {
                
                	if (outboundEditPanel.checkFields()) {
                    	OutboundRecord currRecord = new OutboundRecord();

                		if (outboundEditPanel.updateRecord(currRecord)) {
                    		proxyConfig.proxyConfigData.outboundList.add(currRecord);
                    		outboundTableModel.addRecord(currRecord);
                        	proxyConfig.changeListener.setChanged(true);
                        	break;
                        
                		}
                	}
            	} else {
            	    break;
            	}
            }
            
            ProxyConfig.restoreOptionPaneBackground();

        } else if (cmd.equals("DEL_PATTERN")) {
            OutboundRecord currRecord = (OutboundRecord) outboundTableModel.getRecord(outboundTable.getSelectedRow());
            if (currRecord != null) {
                int retVal = JOptionPane.showConfirmDialog(null, 
                        "Are you sure you want to delete the mapping " + currRecord + " ?", 
                        "Confirm Delete", JOptionPane.YES_NO_OPTION);
                if (retVal == JOptionPane.YES_OPTION) {
                    outboundTableModel.removeRecord(currRecord);
                    proxyConfig.proxyConfigData.outboundList.remove(currRecord);
                    proxyConfig.changeListener.setChanged(true);

                }
                
            } else {
                ProxyConfig.beep();
            }

        } else if (cmd.equals("EDIT_PATTERN")) {
           	ProxyConfig.changeOptionPaneBackground(Color.WHITE);

           	OutboundRecord currRecord = (OutboundRecord) outboundTableModel.getRecord(outboundTable.getSelectedRow());

            if (currRecord != null) {
                OutboundEditPanel outboundEditPanel = new OutboundEditPanel(proxyConfig);
                outboundEditPanel.setRecord(currRecord);
                
                int retVal = JOptionPane.showConfirmDialog(null, 
                        outboundEditPanel, "Modify Path", JOptionPane.OK_CANCEL_OPTION);
                if (retVal == JOptionPane.OK_OPTION) {
                    
                    if (outboundEditPanel.checkFields()) {
                    
                        outboundEditPanel.updateRecord(currRecord);
                    	outboundTableModel.fireTableDataChanged();
                        proxyConfig.changeListener.setChanged(true);

                    }
                }
            } else {
                ProxyConfig.beep();
            }
            
            ProxyConfig.restoreOptionPaneBackground();
            
        }
        
    }
    
    public void addRecord (OutboundRecord rec) {
        outboundTableModel.addRecord( rec );
    }
    public void delRecord (OutboundRecord rec) {
        outboundTableModel.removeRecord(rec);
        
    }
}
